desc 'Runs application on local server (in development mode).'
task :start, :port do |t, args|
  puts 'Processing dependencies'
  require 'bundler'
  # Workaround for https://github.com/mkristian/jbundler/issues/59
  begin
    require 'bundler/vendor/thor/lib/thor/actions/create_file'
  rescue LoadError
    # Require is not valid for older versions of bundler
  end
  ENV['RACK_ENV'] = 'development'
  require 'bundler/cli'
  Bundler::CLI.start(['install'], :debug => false)
  Bundler.reset!

  require 'uu/os/util/embedded_application_server'
  options = {}
  options[:port] = args[:port] || 9292
  puts "Starting application server"
  server = UU::OS::Util::EmbeddedApplicationServer.new(options)
  server.start
  puts "Server started at #{server.base_url}"
  while server.status == :Running
    Thread.pass
  end
end
