require 'json'

module UU
  module OS
    module Server
      # @private
      module JsonParser

        def self.parse(body)

          body = body.read if body.respond_to? :read
          return {} if body.nil? || body.empty?

          begin
            params = JSON.parse(body, symbolize_names: true, quirks_mode: true)
          rescue
            raise TypeError, 'content is not valid JSON'
          end
          return params
        end

      end
    end
  end
end
