require 'rack/request'
require 'uu/os/http/http_headers'
require 'uu/os/http/http_query'

module UU
  module OS
    module Server
      # @private
      class Request < Rack::Request

        def authorization_header
          @env["HTTP_AUTHORIZATION"]
        end

        # def request_uri
        #   return @env["REQUEST_URI"]
        # end

        alias_method :url, :path

        def method
          request_method.to_sym.downcase
        end


        def headers
          @headers ||= UU::OS::HTTP::HTTPHeaders.new(parse_headers)
        end

        def parameters
          UU::OS::HTTP::HTTPQuery.new(params)
        end

        def logger
         @env['uu.logger'] || @env['rack.logger']
        end

        private

        def parse_headers
          @env.inject({}) do |tmp, (key, value)|
            if key =~ /^HTTP_/
              tmp[key[5..-1]] = value.split(',').map(&:strip)
            elsif key =~ /^CONTENT/
              tmp[key] = value.split(',').map(&:strip)
            end
            tmp
          end
        end

      end
    end
  end
end
